<?php
if (!defined('ABSPATH')) exit;

class SmsAlertcURLOTP
{
    public static function sendtemplatemismatchemail($template)
    {
        $username = smsalert_get_option('smsalert_name', 'smsalert_gateway', '');
        $To_mail = smsalert_get_option('alert_email', 'smsalert_general', '');

        //Email template with content
        $params = array(
            'template' => nl2br($template),
            'username' => $username,
            'server_name' => $_SERVER['SERVER_NAME'],
            'admin_url' => admin_url(),
        );
        $emailcontent = get_smsalert_template('template/emails/mismatch_template.php', $params);
        wp_mail($To_mail, 'SMS Alert - Template Mismatch', $emailcontent, 'content-type:text/html');
    }

    public static function checkPhoneNos($nos = NULL, $force_prefix = true)
    {
        $country_code = smsalert_get_option('default_country_code', 'smsalert_general');
        $country_code_enabled = smsalert_get_option('checkout_show_country_code', 'smsalert_general');

        $nos = explode(',', $nos);
        $valid_no = array();
        if (is_array($nos)) {
            foreach ($nos as $no) {
                $no = ltrim(ltrim($no, '+'), '0'); //remove leading + and 0
                $no = preg_replace("/[^0-9]/", "", $no);//remove spaces and special characters

                if (!empty($no)) {
                    if (!$force_prefix) {
                        $no = (substr($no, 0, strlen($country_code)) == $country_code) ? substr($no, strlen($country_code)) : $no;
                    } else {
                        $no = (substr($no, 0, strlen($country_code)) != $country_code) ? $country_code . $no : $no;
                    }
                    $match = preg_match(SmsAlertConstants::getPhonePattern(), $no);
                    if ($match) {
                        $valid_no[] = $no;
                    }
                }
            }
        }

        if (sizeof($valid_no) > 0) {
            return implode(',', $valid_no);
        } else {
            return false;
        }
    }

    public static function sendsms($sms_data)
    {
        #echo "we are inside";
        #print_r($sms_data);
        #die();
        $auth_key = get_option("sms_alert_auth_key");
        $server = get_option("sms_alert_server");
        $dname = get_option("sms_alert_dname");
        $sim = get_option("sms_alert_sim");
        #echo $server.'/admin/index.php?auth_key='.$auth_key.'&route=api';

        $sms_obj = new smsalert_Sms_Sender($auth_key, $server.'/admin/index.php?auth_key='.$auth_key.'&route=api');
//        $phone = self::checkPhoneNos($sms_data['number']);
//        if ($phone === false) {
//            $data = array();
//            $data['status'] = "error";
//            $data['description'] = "Phone number not valid";
//            return json_encode($data);
//        }
        $text = htmlspecialchars_decode($sms_data['sms_body']);
        $response = $sms_obj->sendSMS($sms_data['number'], $text, $dname, $sim);
        return json_encode(["status" => true, "description" => $response]);
//        $response = false;
//        $username = smsalert_get_option('smsalert_name', 'smsalert_gateway');
//        $password = smsalert_get_option('smsalert_password', 'smsalert_gateway');
//        $senderid = smsalert_get_option('smsalert_api', 'smsalert_gateway');
//        $enable_short_url = smsalert_get_option('enable_short_url', 'smsalert_general');
//
//        $phone = self::checkPhoneNos($sms_data['number']);
//        if ($phone === false) {
//            $data = array();
//            $data['status'] = "error";
//            $data['description'] = "Phone number not valid";
//            return json_encode($data);
//        }
//        $text = htmlspecialchars_decode($sms_data['sms_body']);
//        //bail out if nothing provided
//        if (empty($username) || empty($password) || empty($senderid) || empty($text)) {
//            return $response;
//        }
//
//        $url = base64_decode("aHR0cDovL3d3dy5zbXNhbGVydC5jby5pbi9hcGkvcHVzaC5qc29u");
//        $fields = array('user' => $username, 'pwd' => $password, 'mobileno' => $phone, 'sender' => $senderid, 'text' => $text);
//
//        if (!empty($sms_data['schedule'])) {
//            $fields['schedule'] = $sms_data['schedule'];
//        } //add on 27-08-20
//        if ($enable_short_url == 'on') {
//            $fields['shortenurl'] = 1;
//        }
//        $json = json_encode($fields);
//        $fields = apply_filters('sa_before_send_sms', $fields);
//        $response = self::callAPI($url, $fields, null);
//        $response_arr = json_decode($response, true);
//
//        apply_filters('sa_after_send_sms', $response_arr);
//
//        if ($response_arr['status'] == 'error') {
//            $error = (is_array($response_arr['description'])) ? $response_arr['description']['desc'] : $response_arr['description'];
//            if ($error == "Invalid Template Match") {
//                self::sendtemplatemismatchemail($text);
//            }
//        }
//        return $response;
    }

    public static function smsalert_send_otp_token($form, $email = '', $phone = '')
    {

        $phone = self::checkPhoneNos($phone);
        $cookie_value = get_smsalert_cookie($phone);
        $max_otp_resend_allowed = smsalert_get_option('max_otp_resend_allowed', 'smsalert_general');

        if ($cookie_value >= $max_otp_resend_allowed) {
            $data = array();
            $data['status'] = "error";
            $data['description']['desc'] = __("Maximum OTP limit exceeded", "sms-alert");
            return json_encode($data);
        }


        $response = false;
        $username = smsalert_get_option('smsalert_name', 'smsalert_gateway');
        $password = smsalert_get_option('smsalert_password', 'smsalert_gateway');
        $senderid = smsalert_get_option('smsalert_api', 'smsalert_gateway');
        $template = smsalert_get_option('sms_otp_send', 'smsalert_message', SmsAlertMessages::showMessage('DEFAULT_BUYER_OTP'));
        $template = str_replace("[shop_url]", get_site_url(), $template);


        if ($phone === false) {
            $data = array();
            $data['status'] = "error";
            $data['description']['desc'] = __("phone number not valid", "sms-alert");
            return json_encode($data);
        }


//        if (empty($username) || empty($password) || empty($senderid)) {
//            $data = array();
//            $data['status'] = "error";
//            $data['description']['desc'] = __("Wrong SMSAlert credentials", "sms-alert");
//            return json_encode($data);
//        }

        $url = base64_decode("aHR0cDovL3d3dy5zbXNhbGVydC5jby5pbi9hcGkvbXZlcmlmeS5qc29u==");

        $fields = array('user' => $username, 'pwd' => $password, 'mobileno' => $phone, 'sender' => $senderid, 'template' => $template);
        $json = json_encode($fields);
        $response = self::callAPI($url, $fields, null);
        $response_arr = (array)json_decode($response, true);
        if (array_key_exists('status', $response_arr) && $response_arr['status'] == 'error') {
            $error = (is_array($response_arr['description'])) ? $response_arr['description']['desc'] : $response_arr['description'];
            if ($error == "Invalid Template Match") {
                self::sendtemplatemismatchemail($template);
                $response = false;
            }
        } else {
            create_smsalert_cookie($phone, $cookie_value + 1);
        }

        return $response;
    }

    public static function validate_otp_token($mobileno, $otpToken)
    {
        $response = false;
        $username = smsalert_get_option('smsalert_name', 'smsalert_gateway');
        $password = smsalert_get_option('smsalert_password', 'smsalert_gateway');
        $senderid = smsalert_get_option('smsalert_api', 'smsalert_gateway');
        $mobileno = self::checkPhoneNos($mobileno);
        if ($mobileno === false) {
            $data = array();
            $data['status'] = "error";
            $data['description'] = "phone number not valid";
            return json_encode($data);
        }

        if (empty($username) || empty($password) || empty($senderid)) {
            return $response;
        }
        $url = base64_decode("aHR0cDovL3d3dy5zbXNhbGVydC5jby5pbi9hcGkvbXZlcmlmeS5qc29u");

        $fields = array('user' => $username, 'pwd' => $password, 'mobileno' => $mobileno, 'code' => $otpToken);

        $response = self::callAPI($url, $fields, null);
        $content = json_decode($response, true);
        if (isset($content['description']['desc']) && strcasecmp($content['description']['desc'], 'Code Matched successfully.') == 0) {
            clear_smsalert_cookie($mobileno);
        }


        return $response;
    }

    public static function get_senderids($auth = NULL, $server = NULL, $dname = NULL, $sim = 1)
    {
        if (empty($auth) || empty($server) || empty($dname) || empty($sim)) {
            return '';
        }

        #$url = base64_decode("http://www.smsalert.co.in/api/senderlist.json");
        #$url = 'http://www.ricomart.com/api/senderlist.json';
        #$fields = array('user'=>$username, 'pwd'=>$password);
        #$response = self::callAPI($url, $fields, null);
        update_option("sms_alert_auth_key", $auth);
        update_option("sms_alert_server", $server);
        update_option("sms_alert_dname", $dname);
        update_option("sms_alert_sim", $sim);
        return true;
    }

    public static function get_templates($username = NULL, $password = NULL)
    {
        if (empty($username) || empty($password)) {
            return '';
        }
        #$url = base64_decode("aHR0cDovL3d3dy5zbXNhbGVydC5jby5pbi9hcGkvdGVtcGxhdGVsaXN0Lmpzb24=");

        #$fields = array('user' => $username, 'pwd' => $password);

        #$response = self::callAPI($url, $fields, null);
        #return $response;
        return true;
    }

    public static function get_credits()
    {
        $response = false;
        $username = smsalert_get_option('smsalert_name', 'smsalert_gateway');
        $password = smsalert_get_option('smsalert_password', 'smsalert_gateway');

        if (empty($username) || empty($password)) {
            return $response;
        }

        #$url = base64_decode("aHR0cDovL3d3dy5zbXNhbGVydC5jby5pbi9hcGkvY3JlZGl0c3RhdHVzLmpzb24=");

        #$fields = array('user' => $username, 'pwd' => $password);
        #$response = self::callAPI($url, $fields, null);
        #return $response;
        return true;
    }

    public static function group_list()
    {
        $username = smsalert_get_option('smsalert_name', 'smsalert_gateway');
        $password = smsalert_get_option('smsalert_password', 'smsalert_gateway');

        if (empty($username) || empty($password)) {
            return '';
        }

        $url = base64_decode("aHR0cDovL3d3dy5zbXNhbGVydC5jby5pbi9hcGkvZ3JvdXBsaXN0Lmpzb24=");

        $fields = array('user' => $username, 'pwd' => $password);

        $response = self::callAPI($url, $fields, null);
        return $response;
    }

    public static function country_list()
    {
        #$url = base64_decode("aHR0cDovL3d3dy5zbXNhbGVydC5jby5pbi9hcGkvY291bnRyeWxpc3QuanNvbg==");
        $url = 'https://freeotp.ricomart.com/assets/countrylist.json';
        #$response = self::callAPI($url, null, null);
        return file_get_contents($url);
    }

    public static function creategrp()
    {
        $username = smsalert_get_option('smsalert_name', 'smsalert_gateway');
        $password = smsalert_get_option('smsalert_password', 'smsalert_gateway');

        if (empty($username) || empty($password)) {
            return '';
        }

        $url = base64_decode("aHR0cDovL3d3dy5zbXNhbGVydC5jby5pbi9hcGkvY3JlYXRlZ3JvdXAuanNvbg==");

        $fields = array('user' => $username, 'pwd' => $password, 'name' => $_SERVER['SERVER_NAME']);

        #$response = self::callAPI($url, $fields, null);
        return true;
        #return $response;
    }

    public static function create_contact($sms_datas = null, $group_name, $extra_fields = array())
    {
        if (is_array($sms_datas) && sizeof($sms_datas) == 0)
            return false;

        $username = smsalert_get_option('smsalert_name', 'smsalert_gateway');
        $password = smsalert_get_option('smsalert_password', 'smsalert_gateway');

        //$group_name 	= smsalert_get_option( 'group_auto_sync', 'smsalert_general', '');
        $xmlstr = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<group>
</group>
XML;

        $msg = new SimpleXMLElement($xmlstr);
        $user = $msg->addChild('user');
        $user->addAttribute('username', $username);
        $user->addAttribute('password', $password);
        $user->addAttribute('grp_name', $group_name);
        $members = $msg->addChild('members');
        $cnt = 0;
        foreach ($sms_datas as $sms_data) {
            $phone = self::checkPhoneNos($sms_data['number']);

            if ($phone !== false) {
                $member = $members->addChild('member');
                $member->addAttribute('name', $sms_data['person_name']);
                $member->addAttribute('number', $phone);

                if (!empty($extra_fields)) {
                    $memb = $member->addChild('meta-data');
                    foreach ($extra_fields as $key => $value) {
                        $memb->addAttribute($key, $value);
                    }
                }
                $cnt++;
            }

        }
        $xmldata = $msg->asXML();
        $url = base64_decode("aHR0cHM6Ly93d3cuc21zYWxlcnQuY28uaW4vYXBpL2NyZWF0ZWNvbnRhY3R4bWwuanNvbg==");
        $fields = array('data' => $xmldata);
        if ($cnt > 0)
            $i = 0;#$response = self::callAPI($url, $fields, null);
        else
            $i = 0;#$response = json_encode(array('status' => 'error', 'description' => 'Invalid WC Users Contact Numbers'));

        #return $response;
        return true;
    }

    public function send_sms_xml($sms_datas)
    {
        if (is_array($sms_datas) && sizeof($sms_datas) == 0)
            return false;

        $username = smsalert_get_option('smsalert_name', 'smsalert_gateway');
        $password = smsalert_get_option('smsalert_password', 'smsalert_gateway');
        $senderid = smsalert_get_option('smsalert_api', 'smsalert_gateway');

        $xmlstr = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<message>
</message>
XML;
        $msg = new SimpleXMLElement($xmlstr);
        $user = $msg->addChild('user');
        $user->addAttribute('username', $username);
        $user->addAttribute('password', $password);
        $enable_short_url = smsalert_get_option('enable_short_url', 'smsalert_general');
        if ($enable_short_url == 'on') {
            $user->addAttribute('shortenurl', 1);
        }

        $cnt = 0;
        foreach ($sms_datas as $sms_data) {
            $phone = self::checkPhoneNos($sms_data['number']);
            if ($phone !== false) {
                $sms = $msg->addChild('sms');
                $sms->addAttribute('text', $sms_data["sms_body"]);

                $address = $sms->addChild('address');
                $address->addAttribute('from', $senderid);
                $address->addAttribute('to', $phone);
                $cnt++;
            }
        }

        if ($msg->count() <= 1)
            return false;

        $xmldata = $msg->asXML();
        $url = base64_decode("aHR0cDovL3d3dy5zbXNhbGVydC5jby5pbi9hcGkveG1scHVzaC5qc29uPw==");
        $fields = array('data' => $xmldata);
        if ($cnt > 0)
            $i = 0;//$response = self::callAPI($url, $fields, null);
        else
            $i = 0;//$response = json_encode(array('status' => 'error', 'description' => 'Invalid WC Users Contact Numbers'));

        #return $response;
        return true;
    }

    public static function callAPI($url, $params, $headers = array("Content-Type: application/json"))
    {

        $extra_params = array('plugin' => 'woocommerce', 'website' => $_SERVER['SERVER_NAME']);
        $params = (!is_null($params)) ? array_merge($params, $extra_params) : $extra_params;
        $args = array('body' => $params, 'timeout' => 15);
       #$request = wp_remote_post($url, $args);
        #print_r($args);
        #print "<br>";
        #print_r($params);
        #die();
        if(isset($params["mobileno"]) && isset($params["template"])) {
            $convert["number"] = $params["mobileno"];
            $convert["sms_body"] = $params["template"];
            return self::sendsms($convert);
        }
        $data['status'] = "error";
        $data['description'] = "Some error in curl file";
        return json_encode($data) ;

//        if (is_wp_error($request)) {
//            $data = array();
//            $data['status'] = "error";
//            $data['description'] = $request->get_error_message();
//            return json_encode($data);
//        }

        #return wp_remote_retrieve_body($request);
    }
}